#!/usr/bin/perl -w
use strict;
use Palm::PDB;
use Palm::Raw;
use Compress::Zlib;
use Data::Denter;

&Palm::PDB::RegisterPRCHandlers("Palm::Raw", "");

my $filename = $ARGV[0] or die "Usage: $0 <prc-file>";
my $prc = Palm::PDB->new;
$prc->Load($filename) or die "$0: could not load prc: $filename";

my $total = 0;
my $totalcomp = 0;
for my $rc (@{$prc->{'resources'}}) {
        next unless $rc->{'type'} eq 'Tbmp';
        my $len = length($rc->{'data'});

        my ($d,$status) = Compress::Zlib::deflateInit( -Level => 9 );
        my $out;
        my $comp;
        ($out,$status) = $d->deflate($rc->{'data'});
        $comp = $out;
        ($out,$status) = $d->flush();
        $comp .= $out;

        my $complen = length($comp);
        
        $total += $len;
        $totalcomp += $complen;
        print "$len -> $complen\n";
}

print "total           : $total\n";
print "total compressed: $totalcomp\n";

# vim: sw=8 sts=8 et ai
