/* mapview - map viewer for PalmOS
   Copyright (C) 2005  Edwin Steiner <edwin.steiner@gmx.net>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <PalmOS.h>
#include <string.h>
#include <stdio.h>
#include <stdarg.h>
#include "memory.h"
#include "rsrc.h"
#include "debug.h"

void
mapview_assertion_failed(const char *filename,int line,const char *msg)
{
        char *buf;
        int buflen;

        buflen = strlen(filename) + strlen(msg) + 100;
        buf = NEWARRAY(char,buflen);
        if (!buf)
                return;

        sprintf(buf,"%s: %d: %s",filename,line,msg);

        FrmCustomAlert(AlertAssertionFailedID,buf,NULL,NULL);

        FREEARRAY(char,buflen,buf);
}

void
mapview_message_int(const char *fmt,int a)
{
        char *buf;
        int buflen;

        buflen = strlen(fmt) + 100;
        buf = NEWARRAY(char,buflen);
        if (!buf)
                return;

        sprintf(buf,fmt,a);

        FrmCustomAlert(AlertDebugMessageID,buf,NULL,NULL);

        FREEARRAY(char,buflen,buf);
}

void
mapview_message_fmt(const char *fmt,...)
{
        char *buf;
        int buflen;
        va_list va;

        va_start(va,fmt);

        buflen = strlen(fmt) + 1000;
        buf = NEWARRAY(char,buflen);
        if (!buf)
                return;

        /* XXX this is unsafe */
        vsprintf(buf,fmt,va);
        buf[buflen-1] = 0;

        FrmCustomAlert(AlertDebugMessageID,buf,NULL,NULL);

        FREEARRAY(char,buflen,buf);
        va_end(va);
}

/* vim: et sts=8 sw=8 ai
 */
